#ifndef __VR_BMP__
#define __VR_BMP__

struct BMPFileHeader{
  WORD  Type;
  DWORD Size;
  WORD  Res1,Res2;
  DWORD ImgOff;
};

struct BMPInfo{
  DWORD Size;
  DWORD Width,Height;
  WORD Planes;
  WORD BitCount;
  DWORD Compression;
  DWORD SizeImage;
  DWORD XPerMeter,YPerMeter;
  DWORD ClrUsed,ClrImportant;
};

struct RGBQuad{
  BYTE Red,Green,Blue,Res;
};

struct RGB{
  BYTE Blue,Green,Red;
};

struct BMPInf{
  int x,y;
  short bpp,numColors;
};

class BMP{
  public:
  BYTE *Img;
  RGB *Palette;
  BMPInf Info;

  BMP(char*);
  void InstallPal();
  ~BMP();
};



#endif


