#include"curs.h"
#include"texture.h"
#include<math.h>

void DrawLine(VERTEX2D beg,VERTEX2D end,POLYGON* pol,BYTE* screen)
{
  if(beg.y+pol->yc<0||beg.y+pol->yc>199) return;

  if(beg.x>end.x)
  {
	float tmp=beg.x;beg.x=end.x;end.x=tmp;
	tmp=beg.u;beg.u=end.u;end.u=tmp;
	tmp=beg.v;beg.v=end.v;end.v=tmp;
  }

  float width=(float)(end.x-beg.x);
  float du, dv;
  int u, v;

  if(width)
  {
	du=(end.u-beg.u)/width;
	dv=(end.v-beg.v)/width;
  }

  for(int x=1+round(beg.x);x<=round(end.x);x++)
  {
	u=beg.u;
	v=beg.v;

	if((x+pol->xc)<0||(x+pol->xc)>319)
	{
	  beg.u+=du;
	  beg.v+=dv;
	  continue;
	}
	if(v>(pol->texture->Info.y-1)) v=pol->texture->Info.y-1;
	if(v<0) v=0;
	if(u<0) u=0;
	if(u>(pol->texture->Info.x-1)) u=pol->texture->Info.x-1;

	screen[(int(beg.y)+pol->yc)*320+x+pol->xc]=pol->texture->Img[v*pol->texture->Info.x+u];

	beg.u+=du;
	beg.v+=dv;
  }
}