#include"curs.h"
#include<stdio.h>
#include<stdlib.h>
#include<dos.h>
#include<iostream.h>
#include<alloc.h>
#include<io.h>

BYTE* LoadBMP(char* name)
{
  FILE *File;
  BYTE far* pMem=NULL;
  RGBQuad* RGBQ=NULL;
  RGB *pal=NULL;
  BMPFileHeader Hdr;
  BMPInfo Inf;

  if((File=fopen(name,"r"))==NULL) error("Can't open file.\n");
  fread(&Hdr,sizeof(BMPFileHeader),1,File);
  if(Hdr.Type!=19778){fclose(File);error("Not BMP file.\n");}

  fread(&Inf,sizeof(BMPInfo),1,File);
  if((1<<Inf.BitCount)!=256)
  {
    fclose(File);
    error("Wrong number of colors.\n");
  }
  if(!(RGBQ=(RGBQuad*)malloc(sizeof(RGBQuad)*Inf.ClrUsed))||
     !(pal=(RGB*)malloc(sizeof(RGB)*Inf.ClrUsed)))
  {
    fclose(File);
    error("No memory.\n");
  }
  fread(RGBQ,Inf.ClrUsed*4,1,File);

  for(int i=0;i<Inf.ClrUsed;i++)
  {
    pal[i].Red=RGBQ[i].Red>>2;
    pal[i].Green=RGBQ[i].Green>>2;
    pal[i].Blue=RGBQ[i].Blue>>2;
  }
  free(RGBQ);

  RegPal(pal,Inf.ClrUsed);
  free(pal);

  WORD ImgSize=Hdr.Size-Hdr.ImgOff;
  if(!(pMem=(char far*)farmalloc(ImgSize)))
  {
    fclose(File);
    error("No memory.\n");
  }

  fread(pMem,ImgSize,1,File);

  fclose(File);
  return pMem;
}

