#include"curs.h"
#include<dos.h>
#include<alloc.h>
#include<iostream.h>
#include<conio.h>
#include<bios.h>
#include<math.h>

#define esc 0x011b
#define up 0x4800
#define down 0x5000
#define left 0x4b00
#define right 0x4d00
#define GREY_PLUS 20011
#define GREY_MINUS 18989
#define MINUS 3117
#define PLUS 3371
#define EQUAL 3389

#define PI 3.1415926535897

#define ANGLE PI/(90)

void main(int argc,char* argv[])
{
  if(argc!=2) error("Usage: ... file.bmp\n");

  SplashScr();

  BYTE * virt=0;
  BYTE far* VGA;
  POLYGON pol,pol1;
  VERTEX2D a[4];
  VERTEX2D a1[4];
  double angle=PI*3;
  float scal=1;

  int ch;
  if(!(virt=(BYTE*)malloc(64000))) error("No mem.\n");

  VGA=(BYTE*)MK_FP(0xa000,0);
  VidMode(0x13);
  BMP *bmp;
  bmp=new BMP(argv[1]);
  bmp->InstallPal();
  pol.texture=pol1.texture=bmp;


  a1[0].x=a[0].x=-50;
  a1[0].y=a[0].y=-50;
  a1[0].u=a[0].u=0;
  a1[0].v=a[0].v=0;
  pol.vertex[0]=&a[0];

  a1[1].x=a[1].x=50;
  a1[1].y=a[1].y=-50;
  a1[1].u=a[1].u=bmp->Info.x-1;
  a1[1].v=a[1].v=0;
  pol.vertex[1]=&a[1];


  a1[2].x=a[2].x=-50;
  a1[2].y=a[2].y=50;
  a1[2].u=a[2].u=0;
  a1[2].v=a[2].v=bmp->Info.y-1;
  pol.vertex[2]=&a[2];

  pol1.xc=pol.xc=160;
  pol1.yc=pol.yc=100;

  a1[3].x=a[3].x=50;
  a1[3].y=a[3].y=50;
  a1[3].u=a[3].u=bmp->Info.x-1;
  a1[3].v=a[3].v=bmp->Info.y-1;
  pol.vertex[3]=&a[3];

  do
  {
    switch(ch)
    {
      case left:
	   if(angle<PI*2-ANGLE) angle+=ANGLE;
	     else angle+=ANGLE-PI*2;
	   break;

      case right:
	   if(angle>0) angle-=ANGLE;
		 else angle=angle+PI*2-ANGLE;
	   break;

      case up:
	   if(scal<1.6) scal*=1.05;
	   break;

      case down:
	   if(scal>.1) scal/=1.05;
	   break;
      case GREY_PLUS:
	   if(a1[0].x>-100)
	   {
	     a1[0].x=--a1[2].x;
	     a1[1].x=++a1[3].x;
	   }
	   break;
      case GREY_MINUS:
	   if(a1[0].x<-10)
	   {
	     a1[0].x=++a1[2].x;
	     a1[1].x=--a1[3].x;
	   }
	   break;
      case PLUS:
      case EQUAL:
	   if(a1[0].y>-100)
	   {
	     a1[0].y=--a1[1].y;
	     a1[2].y=++a1[3].y;
	   }
	   break;
      case MINUS:
	   if(a1[0].y<-10)
	   {
	     a1[0].y=++a1[1].y;
	     a1[2].y=--a1[3].y;
	   }
	   break;
      }
      rotate(a1,a,angle);
      Scale(a,a,scal);

      ClearScr(virt);
      Texturing(&pol,virt);
      Flip(virt,VGA);
  } while((ch=bioskey(0))!=esc);

  VidMode(0x3);
  delete bmp;
}