#include"curs.h"
#include"texture.h"
#include<math.h>
#include<stdlib.h>

signed int comp(const void* a1,const void *b1)
{
  VERTEX2D **a=(VERTEX2D**)a1,**b=(VERTEX2D**)b1;
  return ((*a)->y)<((*b)->y)?-1:1;
}


void Texturing(POLYGON* pol,BYTE *screen)
{
  VERTEX2D *a[4],*tmpV,beg,end;

  double u,v,dx1,dx2,du1,dv1,du2,dv2,tmp;
  double height;

  for(int i=0;i<4;i++) a[i]=pol->vertex[i];

  qsort(a,4,sizeof(VERTEX2D*),comp);

  if((int)a[3]->y==(int)a[0]->y) return;

  beg.x=end.x=a[0]->x;
  beg.y=end.y=a[0]->y;
  beg.u=end.u=a[0]->u;
  beg.v=end.v=a[0]->v;

  if(height=a[1]->y-a[0]->y)
  {
    dx1=(a[1]->x-a[0]->x)/height;
    du1=(a[1]->u-a[0]->u)/height;
    dv1=(a[1]->v-a[0]->v)/height;
  }

  if(height=a[2]->y-a[0]->y)
  {
    dx2=(a[2]->x-a[0]->x)/height;
    du2=(a[2]->u-a[0]->u)/height;
    dv2=(a[2]->v-a[0]->v)/height;
  }

  if(a[1]->y==a[0]->y) dx2=dx2;

  for(beg.y=int(a[0]->y);beg.y<round(a[1]->y);beg.y++)
  {
    DrawLine(beg,end,pol,screen);
    beg.x+=dx1;
    beg.u+=du1;
    beg.v+=dv1;

    end.x+=dx2;
    end.u+=du2;
    end.v+=dv2;
  }

 //*************************************************

  if(a[3]->y-a[1]->y)
  {
    height=(a[3]->y-a[1]->y);
    dx1=(a[3]->x-a[1]->x)/height;
    du1=(a[3]->u-a[1]->u)/height;
    dv1=(a[3]->v-a[1]->v)/height;

    beg.x=a[1]->x;
    beg.y=a[1]->y;
    beg.u=a[1]->u;
    beg.v=a[1]->v;

    if(a[1]->y==a[0]->y)
    {
      dx1=dx2=0;
      if(du1+du2==0) du1=du2=0;
      if(dv1+dv2==0) dv1=dv2=0;
    }

    for(beg.y=int(a[1]->y);beg.y<round(a[2]->y);beg.y++)
    {
      DrawLine(beg,end,pol,screen);
      beg.x+=dx1;
      beg.u+=du1;
      beg.v+=dv1;

      end.x+=dx2;
      end.u+=du2;
      end.v+=dv2;
    }
  }

  if(height=(a[3]->y-a[2]->y))
  {
    dx2=(a[3]->x-a[2]->x)/height;
    du2=(a[3]->u-a[2]->u)/height;
    dv2=(a[3]->v-a[2]->v)/height;

    end.x=a[2]->x;
    end.y=a[2]->y;
    end.u=a[2]->u;
    end.v=a[2]->v;

    for(beg.y=int(a[2]->y);beg.y<round(a[3]->y);beg.y++)
    {
      DrawLine(beg,end,pol,screen);
      beg.x+=dx1;
      beg.u+=du1;
      beg.v+=dv1;

      end.x+=dx2;
      end.u+=du2;
      end.v+=dv2;
    }
  }
}